<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2014-2015 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douco.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议：http://www.douco.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo
 * Release Date: 2015-06-10
 */
define('IN_DOUCO', true);

require (dirname(__FILE__) . '/include/init.php');

// rec操作项的初始化
$step = $_REQUEST['step'] ? trim($_REQUEST['step']) : 'default';

// 遍历备份目录是否有备份文件
$sqlfiles = glob(ROOT_PATH . D_PATH . '/data/backup/*.sql'); // 以文件名排序获取备份文件列表（分卷第一个文件会排在第一个）
$sql_filename = $sqlfiles ? basename($sqlfiles['0']) : ''; // 选取第一个备份文件，如果是分卷第一个文件会过滤掉分卷后的“_数据编号”

if (!$can_not_connect_mysql) {
    // 如果已经存在数据库则通过hash_code计算出一个备份文件名
    $hash_code = $dou->get_one("SELECT value FROM " . $dou->table('config') . " WHERE name = 'hash_code'");
    $back_filename = 'D' . strtoupper(substr(md5($hash_code), 8, 15));
}

/**
 +----------------------------------------------------------
 * 起始页面
 +----------------------------------------------------------
 */
if ($step == 'default') {
    if ($can_not_connect_mysql) {
        header("Location: " . ROOT_URL . D_PATH . '/index.php?step=set_config');
        exit;
    }
 
    // 预读取文章列表
    $article_list = $dede->article('list', 5);
    
    // 预读取商品列表
    $product_list = $dede->product('list', 5);

    $smarty->assign('title', $_LANG['dede_title']);
    $smarty->assign('cue', $cue);
    $smarty->assign('article_list', $article_list);
    $smarty->assign('product_list', $product_list);
    $smarty->assign('backed', $backed);
    $smarty->display('index.htm');
}

/**
 +----------------------------------------------------------
 * 转换
 +----------------------------------------------------------
 */
elseif ($step == 'transform') {
    // 清空
    $dou->query("TRUNCATE " . $dou->table('article'));
    $dou->query("TRUNCATE " . $dou->table('article_category'));
    $dou->query("TRUNCATE " . $dou->table('product'));
    $dou->query("TRUNCATE " . $dou->table('product_category'));
    $dou->query("DELETE FROM " . $dou->table('file') . " WHERE module = 'artilce' OR module = 'product'");
 
    // 导入分类
    $dede->category('article', 1);
    $dede->category('product', 6);
 
    // 导入数据
    $dede->article('transform');
    $dede->product('transform');
 
    $dede->dou_header('index.php?step=success');
}

/**
 +----------------------------------------------------------
 * 转换 成功
 +----------------------------------------------------------
 */
elseif ($step == 'success') {
    $smarty->assign('title', $_LANG['dede_success']);
    $smarty->display('success.htm');
}

/**
 +----------------------------------------------------------
 * 修改配置文件
 +----------------------------------------------------------
 */
elseif ($step == 'set_config') {
    // config.php文件
    $dede_config = ROOT_PATH . D_PATH . '/data/config.php';
    include_once ($dede_config);
    $config = array (
            "dede_dbhost" => $dede_dbhost,
            "dede_dbname" => $dede_dbname,
            "dede_dbuser" => $dede_dbuser,
            "dede_dbpass" => $dede_dbpass,
            "dede_prefix" => $dede_prefix
    );
    
    $smarty->assign('title', $_LANG['dede_setting']);
    $smarty->assign('config', $config);
    $smarty->display('setting.htm');
}

/**
 +----------------------------------------------------------
 * 修改配置文件.提交
 +----------------------------------------------------------
 */
elseif ($step == 'set_config_post') {
    // config.php文件
    $dede_config = ROOT_PATH . D_PATH . '/data/config.php';
    include_once ($dede_config);
    
    // 读取config.php里的内容
    $config_str = "<?php\r\n";
    $config_str .= "/**\r\n";
    $config_str .= " * DouPHP\r\n";
    $config_str .= " * --------------------------------------------------------------------------------------------------\r\n";
    $config_str .= " * 版权所有 2014-2015 漳州豆壳网络科技有限公司，并保留所有权利。\r\n";
    $config_str .= " * 网站地址: https://www.douphp.com\r\n";
    $config_str .= " * --------------------------------------------------------------------------------------------------\r\n";
    $config_str .= " * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。\r\n";
    $config_str .= " * 授权协议: https://www.douphp.com/license.html\r\n";
    $config_str .= " * --------------------------------------------------------------------------------------------------\r\n";
    $config_str .= " * Author: DouCo\r\n";
    $config_str .= " * Release Date: 2020-06-01\r\n";
    $config_str .= " */\r\n\r\n";
    
    $config_str .= "// database host\r\n";
    $config_str .= '$dede_dbhost   = \'' . $_POST['dede_dbhost'] . '\';' . "\r\n\r\n";
    
    $config_str .= "// database name\r\n";
    $config_str .= '$dede_dbname   = \'' . $_POST['dede_dbname'] . '\';' . "\r\n\r\n";
    
    $config_str .= "// database username\r\n";
    $config_str .= '$dede_dbuser   = \'' . $_POST['dede_dbuser'] . '\';' . "\r\n\r\n";
    
    $config_str .= "// database password\r\n";
    $config_str .= '$dede_dbpass   = \'' . $_POST['dede_dbpass'] . '\';' . "\r\n\r\n";
    
    $config_str .= "// table prefix\r\n";
    $config_str .= '$dede_prefix   = \'' . $_POST['dede_prefix'] . '\';' . "\r\n\r\n";
    
    $config_str .= "?>";
    
    file_put_contents($dede_config, $config_str);
 
    header("Location: " . ROOT_URL . D_PATH);
    exit;
}

?>